package scws;

public class Interval<T extends Comparable<T>> {
	private T begin;
	private T end;
	public Interval(T e1, T e2) {
		if(e1.compareTo(e2) <= 0) {
			begin = e1;
			end   = e2;
		} else {
			begin = e2;
			end   = e1;
		}
	}
	public boolean hasIntersection(Interval<T> othr) {
		return (this.begin.compareTo(othr.end) <= 0)
			&& (othr.begin.compareTo(this.end) <= 0);
	}
	@Override
	public boolean equals(Object othr) {
		return othr instanceof Interval<?>
			&& this.begin.equals(((Interval<?>)othr).begin)
			&& this.end.equals(((Interval<?>)othr).end);
	}
}
